var feed = {url:"http://www.little-men.com/lme_widget.xml"};
var scrollArea, scrollbar;

function load ()
{
	scrollbar = new AppleVerticalScrollbar(document.getElementById("myScrollBar"));
	scrollArea = new AppleScrollArea(document.getElementById("contents"), scrollbar);
	scrollArea.scrollsHorizontally = false;
	scrollArea.singlepressScrollPixels = 15;
	
	scrollArea.focus(); // for key control when first loading in Safari
	
	window.onfocus = function () { scrollArea.focus(); }
	window.onblur = function () { scrollArea.blur(); }
	
	if (!window.widget)
	{
		show ();
	}
}


var last_updated = 0;
var xml_request = null;

function show ()
{
	var now = (new Date).getTime();
	
	// only check if 15 minutes have passed
	if ((now - last_updated) > 900000)
	{
		if (xml_request != null)
		{
			xml_request.abort();
			xml_request = null;
		}
		xml_request = new XMLHttpRequest();

		xml_request.onload = function(e) {xml_loaded(e, xml_request);}
		xml_request.overrideMimeType("text/xml");
		xml_request.open("GET", feed.url);
		xml_request.setRequestHeader("Cache-Control", "no-cache");
		xml_request.send(null);
    }
}

if (window.widget)
{
	widget.onshow = show;
}


function findChild (element, nodeName)
{
	var child;
	
	for (child = element.firstChild; child != null; child = child.nextSibling)
	{
		if (child.nodeName == nodeName)
			return child;
	}
	
	return null;
}

function xml_loaded (e, request) 
{
	xml_request = null;
	if (request.responseXML)
	{		
		var contents = document.getElementById('contents');
		while (contents.hasChildNodes())
		{
			contents.removeChild(contents.firstChild);
		}
		
		// Get the top level <rss> element 
		var rss = findChild(request.responseXML, 'rss');
		if (!rss) {
			alert("no <rss> element"); 
			document.getElementById("ohnoes").style.display = "block";
			return;
		}
		
		// Get single subordinate channel element
		var channel = findChild( rss, 'channel');
		if (!channel) {
			alert("no <channel> element");
			document.getElementById("ohnoes").style.display = "block";
			return;
		}
		
		
		document.getElementById("ohnoes").style.display = "none";

		var results = new Array;
		
		for( var item = channel.firstChild; item != null; item = item.nextSibling)
		{
			if( item.nodeName == 'item' ) 
			{
				var title = findChild (item, 'title');
			
				// we have to have the title to include the item in the list 
				if( title != null ) 
				{
					var link = findChild (item, 'link');
					var description = findChild (item, 'description');
					results[results.length] = {title:title.firstChild.data, 
						link:(link != null ? link.firstChild.data : null),
						description:(link != null ? description.firstChild.data : null)
				   };
				}
			}
		}
				
		// copy title and date into rows for display. Store link so it can be used when user
		// clicks on title or button
		nItems = results.length;
		var even = true;		
				
		for (var i = 0; i < nItems; ++i)
		{
			var item = results[i];
			var row = createRow (item.title, item.link, item.description, even);
			even = !even;
			
			contents.appendChild (row);
		}

		// update the scrollbar so scrollbar matches new data
		scrollArea.refresh();
		
		// set last_updated to the current time to keep track of the last time a request was posted
		last_updated = (new Date).getTime();
	}
}

function compFunc (a, b)
{
	if (a.date < b.date)
		return 1;
	else if (a.date > b.date)
		return -1;
	else
		return 0;
}

function createRow (title, link, description, even)
{
	var row = document.createElement ('div');
	row.setAttribute ('class', 'row ' + (even ? 'light' : 'dark'));
	
	var title_div = document.createElement ('div');
	title_div.innerText = title;
	title_div.setAttribute ('class', 'title');
	
	row.appendChild (title_div);
	
	var desc_div = document.createElement ('div');
	desc_div.innerText = description;
	desc_div.setAttribute ('class', 'description');
	row.appendChild (desc_div);
	
	if (link != null) {
		var btn_div = document.createElement ('div');
		btn_div.innerText = "collection animated gallery";
		btn_div.setAttribute ('class', 'btn');
		btn_div.setAttribute ('the_link', link);
		btn_div.setAttribute ('onclick', 'clickOnTitle (event, this);');
		row.appendChild (btn_div);
	}
	
	return row;	
}

function createDateStr (date)
{
	var month;
	switch (date.getMonth())
	{
		case 0: month = 'Jan'; break;
		case 1: month = 'Feb'; break;
		case 2: month = 'Mar'; break;
		case 3: month = 'Apr'; break;
		case 4: month = 'May'; break;
		case 5: month = 'Jun'; break;
		case 6: month = 'Jul'; break;
		case 7: month = 'Aug'; break;
		case 8: month = 'Sep'; break;
		case 9: month = 'Oct'; break;
		case 10: month = 'Nov'; break;
		case 11: month = 'Dec'; break;
	}	
	return month + ' ' + date.getDate();
}

function clickOnTitle (event, div)
{
	if (window.widget)
	{
		widget.openURL (div.getAttribute('the_link'));
	} else document.location = div.getAttribute('the_link');
}

function clickOnFeedTitle(event)
{
	if (window.widget)
	{
			widget.openURL (feed.url);
	} else document.location = feed.url;
}

function clickOnPurchase (event)
{
	if (window.widget)
	{
		widget.openURL ('http://store.kagi.com/cgi-bin/store.cgi?storeID=6FDFG_LIVE&&');
	} else document.location = 'http://store.kagi.com/cgi-bin/store.cgi?storeID=6FDFG_LIVE&&';
}